%%
clc
clear;

%% read image and construct linear operator
img = im2double(imread('cat_noisy.jpg'));
[ny, nx, c] = size(img);
n = ny*nx*c;
f = img(:);

% TODO: construct the linear operator for 3 channels.

%% optimization part
% initialize the parameters
u = f;
max_iters = 30;

% huber parameter
epsilon = 0.1;

% weight for regularizor
rho = 0.6;

% arrays to record the energy.
primal_eng = zeros(1,max_iters);
dual_eng = zeros(1,max_iters);

D = rho*D;

% TODO: Implement the majorize minimization and at each iteration, check
% the duality gap.
for i = 1:max_iters
    
    fprintf('iteration: %d, duality gap: %.4e\n', i, primal_eng(i) + dual_eng(i));
end

%% visualization
imshow(reshape(u, ny, nx,c));